#ifndef __RC6_H
#define __RC6_H

#include <sys/types.h>

#define RC6_ROUNDS     20
#define RC6_WORDSIZE   32

struct rc6key
  {
    u_int32_t key[RC6_ROUNDS * 2 + 4];
  };

#define RC6_P32 0xB7E15163L
#define RC6_Q32 0x9E3779B9L

#ifdef __cplusplus
extern "C"
{
#endif

  int rc6initkey (struct rc6key *key, void *userkey, int len);
  int rc6encrypt (struct rc6key *key, void *in, void *out);
  int rc6decrypt (struct rc6key *key, void *in, void *out);

#ifdef __cplusplus
};
#endif

#endif
