/*
 * This code tests the RC6-32/20 block cipher implementation.
 *
 * This code was written by Martin Hinner <mhi@penguin.cz> in 1999,
 * no copyright is claimed. This code is in the public domain; do
 * with it what you wish.
 * 
 * For RC6 copyright information see www.rsa.com.
 */
#include <stdio.h>
#include "rc6.h"

/*
 * Dump buffer to screen
 */
void
dump (char *buf, int len)
{
  while (len--)
    {
      printf ("%02X ", (*buf++) & 0xFF);
    }
  printf ("\n");
}

int
main ()
{
  struct rc6key key;
  char plaintext[16], ciphertext[16], decrypted[16];
  char mykey[0x10];

  memset (mykey, 0, 16);
  memset (plaintext, 0, 16);

  rc6initkey (&key, mykey, 16);
  rc6encrypt (&key, plaintext, ciphertext);
  rc6decrypt (&key, ciphertext, decrypted);

  dump (plaintext, 16);
  dump (ciphertext, 16);
  dump (decrypted, 16);

  return 0;
}
